<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 2.5 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="./">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-RC1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-RC1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 2.5: Computing state spaces</h1>
                    <p>
                        We discussed the concept of a state space of a discrete event system before, in Modules 1.2 and 1.3.
                        You learned that a state consists of a current location for each automaton, and a current value for each variable.
                        And the state space consists of all reachable states and the transitions between them.
                    </p>
                    <p>
                        We have since discussed interaction of automata, through synchronization on shared events, as well as reading shared variables.
                        It is therefore time to revisit the concept of state space, and learn how to compute it.
                    </p>
                    <p>
                        First, we will compute the state space for a model without variables.
                        Then, we consider the more general case of computing the state space of a model with variables.
                    </p>

                    <h2>Without variables</h2>
                    <p>
                        Rather than modeling a large system using a single automaton, you learned how to model it using multiple automata that synchronize.
                        Of course, the behavior of the single automaton and the multiple synchronizing automata should then be the same, if they model the same system.
                        That is, they should have the same state space.
                    </p>
                    <p>
                        A model with multiple synchronizing automata can be transformed to a single automaton, with the same behavior.
                        Each location of the resulting automaton then represents a state of the state space, and thus a current location of each automaton, and a current value of each variable.
                    </p>
                    <p>
                        Remember that an event that is not shared between automata, can occur when the one automaton that uses it can take an edge for the event.
                        But, for events that are shared between two or more automata, they can only perform the event together, as they must synchronize and take their edges at the same time.
                    </p>
                    <p>
                        To compute the state space, we start by making an empty automaton to represent the computed state space.
                        We then identify the initial state, and we make an initial location for it in the empty automaton.
                        We then see what transitions are possible for the different events of the system, and add edges for them.
                        By taking the transitions, we likely reach new states, and we add new locations for them.
                        We then explore the transitions from these new states and add edges for them, and we also add new locations for the new states that we reach, and so on.
                        We mark every location as marked, if the corresponding state is marked.
                    </p>
                    <p>
                        Let's see how this works, by means of an example:
                    </p>
                    <img src="images/compute-state-space-example-automaton1.png">
                    <img src="images/compute-state-space-example-automaton2.png">
                    <p>
                        We have two automata, and both have two locations.
                        The initial state consists of the first automaton being in its location <code>L1</code>, and the second automaton in its location <code>R1</code>.
                        We can represent this as <code>(L1, R2)</code>.
                        We make a new automaton to represent the state space, and a location to it for this initial state.
                        Location <code>R1</code> is a marked location, but location <code>L1</code> is not, so the initial state is not marked.
                        We thus do not mark the initial location of the state space automaton.
                        The following figure shows the state space we have constructed so far:
                    </p>
                    <img src="images/compute-state-space-example-result1.png">
                    <p>
                        The example has three events: <code>a</code>, <code>b</code> and <code>c</code>.
                        We check whether transitions are possible for these events, from the initial state.
                        We start with event <code>a</code>.
                        Neither location <code>L1</code>, nor location <code>R1</code> has an outgoing edge for the event, so no transitions for event <code>a</code> is possible in the initial state.
                        We then proceed to event <code>b</code>.
                        The first automaton has an outgoing edge for the event in location <code>L1</code>.
                        But, the second automaton also uses the event, and has no outgoing edge for the event, from its location <code>R1</code>.
                        In the initial state, it is thus not possible for the two automata to synchronize for the event, and therefore no transitions are possible for <code>b</code> in the initial state.
                        We then proceed to event <code>c</code>.
                        The second automaton has an outgoing edge for it in location <code>R1</code>.
                        The first automaton does not, but it does not synchronize on the event, the second automaton can perform a transitions for the event by itself.
                        This is thus the only transition possible in the initial state.
                        By taking this transition, the first automaton remains in its <code>L1</code> location, as it does not participate.
                        And the second automaton goes from its <code>R1</code> location to its <code>R2</code> location.
                        We thereby reach a new state <code>(L1, R2)</code>, and add a new location for it in the state space automaton.
                        Location <code>L1</code> is not marked, and neither is location <code>R2</code>, so the new state is not marked.
                        We add an edge to connect the two locations, as the two states of the state space are connected by the transition.
                        We have considered all transitions from the initial state, and thus all states that can be reached from it by a single transition.
                        The following figure shows the state space we have constructed so far:
                    </p>
                    <img src="images/compute-state-space-example-result2.png">
                    <p>
                        We proceed to the <code>(L1, R2)</code> state, to see what transitions are possible from that state.
                        Here, transitions for events <code>a</code> and <code>c</code> are not possible.
                        A transition for event <code>b</code> is possible, since both locations <code>L1</code> and <code>R2</code> have outgoing edges for the event.
                        The two automata synchronize and take their edges at the same time, resulting in a single transition for event <code>b</code>.
                        This takes us to yet another new state, namely <code>(L2, R1)</code>.
                        We add a new location for this state, and also add an edge for the transition.
                        Since both <code>L2</code> and <code>R1</code> are marked, the new state is a marked state, and we thus mark the new location of the state space automaton.
                        The following figure shows the state space we have constructed so far:
                    </p>
                    <img src="images/compute-state-space-example-result3.png">
                    <p>
                        We then consider the transitions possible from state <code>(L2, R1)</code>.
                        A transition for event <code>a</code> is possible in the first automaton.
                        The second automaton does not participate.
                        The transition takes us to state <code>(L1, R1)</code>, which is the initial state.
                        Since no new state is reached, we don't add a new location.
                        We do add an edge for the new transition, between the locations representing states <code>(L2, R1)</code> and <code>(L1, R1)</code>.
                        No transition is possible for event <code>b</code>, as neither automaton has an outgoing edge for it in its current location.
                        A transition is possible for event <code>c</code>, in which only the second automaton participates.
                        We reach a new state, <code>(L2, R2)</code>, for which we add a new unmarked location to the state space automaton.
                        We also add an edge for the new transition.
                        The following figure shows the state space we have constructed so far:
                    </p>
                    <img src="images/compute-state-space-example-result4.png">
                    <p>
                        We then consider the transitions possible from state <code>(L2, R2)</code>.
                        A transition is possible for event <code>a</code>, in which only the first automaton participates.
                        This takes us to state <code>(L1, R2)</code> that we have seen before.
                        We add an edge for the new transition, but since no new state is reached, we don't add a new location.
                        No transitions are possible for events <code>b</code> and <code>c</code>.
                        We have explored all transitions that are possible from all of the reachable states, and have thus computed the full state space.
                        The following figure shows the complete state space:
                    </p>
                    <img src="images/compute-state-space-example-result5.png">
                    <p>
                        The model with the computed state space automaton has the same behavior as the original model with the two synchronizing automata.
                        The same sequences of events are possible in both models.
                        And if a part of such a sequence is executed on both models, they each reach a certain state, and these two states that are either both marked or both unmarked.
                    </p>

                    <h2>With variables</h2>
                    <p>
                        Now let's consider the computation of a state space for a model with variables.
                        The procedure is mostly the same.
                        We start again by determining the initial state.
                        This time we need to consider not only the initial locations of the automata, but also the initial values of the variables.
                        The initial state is a marked state if initial locations of the automata are also marked locations, and the initial values of the variables are marked values.
                    </p>
                    <p>
                        We then consider possible transitions from the initial state.
                        We therefore consider again each event separately.
                        We check whether each automaton that synchronizes over the event has an outgoing edge from its current location.
                        But, additionally, we consider whether the guards of the edges are enabled by evaluating them using the current values of the variables.
                        We see which new states we reach by taking the transitions.
                        For this, we consider not only the new locations that are reached by the edges of the automata, but also the new values that the variables get by executing the updates of the edges.
                    </p>
                    <p>
                        As for models without variables, we keep exploring possible transitions from new states that we reach, and thereby we reach either new states or states that we had already reached before.
                        Once no more new states are reached, we have computed the full state space.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: `
                                    In the above example without variables, the states of the state space cover all the possible combinations of locations of the two automata: <code>(L1, R1)</code>, <code>(L1, R2)</code>, <code>(L2, R1)</code> and <code>(L2, R2)</code>.
                                    Is it always the case that the states of the state space are all possible combinations of the locations of the separate automata for which the product is computed (assuming no variables, and that all locations are locally reachable in each automaton)?
                                    So, if a model has 3 automata with 3 locations each, the state space has 3<sup>3</sup> = 27 locations?`,
                                answers: [
                                    "Yes, this is indeed always the case, per definition.",
                                    "This depends on whether the model contains non-deterministic automata.",
                                    "No, some states may not be reachable because shared events must synchronize."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    A model consists of 3 automata with respectively 2, 3 and 4 locations.
                                    Within each automaton, all locations are reachable.
                                    Each event is used by only one automaton.
                                    How many locations does the state space have?`,
                                answers: [
                                    "This can not be determined without more information.",
                                    "29, because 2<sup>2</sup> + 3<sup>2</sup> + 4<sup>2</sup> = 29.",
                                    "24, because 2 * 3 * 4 = 24."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "Can the behavior of the state space that is computed be different than the behavior of the model from which it is computed?",
                                answers: [
                                    "Yes.",
                                    "No.",
                                    "It depends."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Which of the statements is true about the following CIF model (as a whole, not per automaton)?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b, c;

                                            automaton aut1:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge b goto y;

                                                location y:
                                                    edge c goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "It has a deadlock state.",
                                    "It has no deadlock state.",
                                    "It has a blocking state.",
                                    "It is non-blocking.",
                                    "It has a livelock state.",
                                    "It has no livelock state.",
                                ],
                                correctAnswer: '2, 4, 6'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Which of the statements is true about the following CIF model (as a whole, not per automaton)?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b;

                                            automaton aut1:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                location x:
                                                    initial;
                                                    edge a goto y;

                                                location y:
                                                    marked;
                                                    edge b goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "It has a deadlock state.",
                                    "It has no deadlock state.",
                                    "It has a blocking state.",
                                    "It is non-blocking.",
                                    "It has a livelock state.",
                                    "It has no livelock state.",
                                ],
                                correctAnswer: '2, 3, 5'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Which of the statements is true about the following CIF model (as a whole, not per automaton)?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b;

                                            automaton aut1:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge b goto y;

                                                location y:
                                                    edge a goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "It has a deadlock state.",
                                    "It has no deadlock state.",
                                    "It has a blocking state.",
                                    "It is non-blocking.",
                                    "It has a livelock state.",
                                    "It has no livelock state.",
                                ],
                                correctAnswer: '1, 4, 6'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Which of the statements is true about the following CIF model (as a whole, not per automaton)?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b, c;

                                            automaton aut1:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                location x:
                                                    initial;
                                                    edge b goto y;

                                                location y:
                                                    marked;
                                                    edge c goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "It has a deadlock state.",
                                    "It has no deadlock state.",
                                    "It has a blocking state.",
                                    "It is non-blocking.",
                                    "It has a livelock state.",
                                    "It has no livelock state.",
                                ],
                                correctAnswer: '2, 4, 6'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    How many states does the state space of the following CIF model have?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b, c;

                                            automaton aut1:
                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                location x:
                                                    initial;
                                                    edge b goto y;

                                                location y:
                                                    marked;
                                                    edge c goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "Zero.",
                                    "One.",
                                    "Two.",
                                    "Three.",
                                    "Four.",
                                    "Five."
                                ],
                                correctAnswer: '5'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    How many states does the state space of the following CIF model have?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b, c;

                                            automaton aut1:
                                                disc int v = 0;

                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a when v &lt; 3 and v = aut2.v do v := v + 1 goto y;

                                                location y:
                                                    edge b goto x;
                                            end

                                            automaton aut2:
                                                disc int v = 0;

                                                location x:
                                                    initial;
                                                    edge b goto y;

                                                location y:
                                                    marked;
                                                    edge c do v := v + 1 goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "Zero.",
                                    "One.",
                                    "Two.",
                                    "Three.",
                                    "Four.",
                                    "Five.",
                                    "Six.",
                                    "Seven.",
                                    "Eight.",
                                    "Nine.",
                                    "Ten.",
                                    "Eleven.",
                                    "Twelve.",
                                    "Infinitely many."
                                ],
                                correctAnswer: '11'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    How many states does the state space of the following CIF model have?
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            event a, b, c;

                                            automaton aut1:
                                                disc int v = 0;

                                                location x:
                                                    initial;
                                                    marked;
                                                    edge a when v &lt; 3 do v := v + 1 goto y;

                                                location y:
                                                    edge b when v = aut2.v goto x;
                                            end

                                            automaton aut2:
                                                disc int v = 0;

                                                location x:
                                                    initial;
                                                    edge b goto y;

                                                location y:
                                                    marked;
                                                    edge c do v := v + 1 goto x;
                                            end
                                        </code>
                                    </pre>`,
                                answers: [
                                    "Zero.",
                                    "One.",
                                    "Two.",
                                    "Three.",
                                    "Four.",
                                    "Five.",
                                    "Six.",
                                    "Seven.",
                                    "Eight.",
                                    "Nine.",
                                    "Ten.",
                                    "Eleven.",
                                    "Twelve.",
                                    "Infinitely many."
                                ],
                                correctAnswer: '3'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="shared-variables.html">Go back to Module 2.4</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="cif-tools-view-analyze-models.html">Proceed to Module 2.6</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
